~ [ source navigation ] ~ [ diff markup ] ~ [ identifier search ] ~

TOMOYO Linux Cross Reference
Linux/scripts/link-vmlinux.sh

Version: ~ [ linux-6.11.5 ] ~ [ linux-6.10.14 ] ~ [ linux-6.9.12 ] ~ [ linux-6.8.12 ] ~ [ linux-6.7.12 ] ~ [ linux-6.6.58 ] ~ [ linux-6.5.13 ] ~ [ linux-6.4.16 ] ~ [ linux-6.3.13 ] ~ [ linux-6.2.16 ] ~ [ linux-6.1.114 ] ~ [ linux-6.0.19 ] ~ [ linux-5.19.17 ] ~ [ linux-5.18.19 ] ~ [ linux-5.17.15 ] ~ [ linux-5.16.20 ] ~ [ linux-5.15.169 ] ~ [ linux-5.14.21 ] ~ [ linux-5.13.19 ] ~ [ linux-5.12.19 ] ~ [ linux-5.11.22 ] ~ [ linux-5.10.228 ] ~ [ linux-5.9.16 ] ~ [ linux-5.8.18 ] ~ [ linux-5.7.19 ] ~ [ linux-5.6.19 ] ~ [ linux-5.5.19 ] ~ [ linux-5.4.284 ] ~ [ linux-5.3.18 ] ~ [ linux-5.2.21 ] ~ [ linux-5.1.21 ] ~ [ linux-5.0.21 ] ~ [ linux-4.20.17 ] ~ [ linux-4.19.322 ] ~ [ linux-4.18.20 ] ~ [ linux-4.17.19 ] ~ [ linux-4.16.18 ] ~ [ linux-4.15.18 ] ~ [ linux-4.14.336 ] ~ [ linux-4.13.16 ] ~ [ linux-4.12.14 ] ~ [ linux-4.11.12 ] ~ [ linux-4.10.17 ] ~ [ linux-4.9.337 ] ~ [ linux-4.4.302 ] ~ [ linux-3.10.108 ] ~ [ linux-2.6.32.71 ] ~ [ linux-2.6.0 ] ~ [ linux-2.4.37.11 ] ~ [ unix-v6-master ] ~ [ ccs-tools-1.8.9 ] ~ [ policy-sample ] ~
Architecture: ~ [ i386 ] ~ [ alpha ] ~ [ m68k ] ~ [ mips ] ~ [ ppc ] ~ [ sparc ] ~ [ sparc64 ] ~

Diff markup

Differences between /scripts/link-vmlinux.sh (Version linux-6.11.5) and /scripts/link-vmlinux.sh (Version linux-5.4.284)


  1 #!/bin/sh                                           1 #!/bin/sh
  2 # SPDX-License-Identifier: GPL-2.0                  2 # SPDX-License-Identifier: GPL-2.0
  3 #                                                   3 #
  4 # link vmlinux                                      4 # link vmlinux
  5 #                                                   5 #
  6 # vmlinux is linked from the objects in vmlinu !!   6 # vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_OBJS) and
  7 # vmlinux.a contains objects that are linked u !!   7 # $(KBUILD_VMLINUX_LIBS). Most are built-in.a files from top-level directories
                                                   >>   8 # in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
  8 # $(KBUILD_VMLINUX_LIBS) are archives which ar      9 # $(KBUILD_VMLINUX_LIBS) are archives which are linked conditionally
  9 # (not within --whole-archive), and do not req     10 # (not within --whole-archive), and do not require symbol indexes added.
 10 #                                                  11 #
 11 # vmlinux                                          12 # vmlinux
 12 #   ^                                              13 #   ^
 13 #   |                                              14 #   |
 14 #   +--< vmlinux.a                             !!  15 #   +--< $(KBUILD_VMLINUX_OBJS)
                                                   >>  16 #   |    +--< init/built-in.a drivers/built-in.a mm/built-in.a + more
 15 #   |                                              17 #   |
 16 #   +--< $(KBUILD_VMLINUX_LIBS)                    18 #   +--< $(KBUILD_VMLINUX_LIBS)
 17 #   |    +--< lib/lib.a + more                     19 #   |    +--< lib/lib.a + more
 18 #   |                                              20 #   |
 19 #   +-< ${kallsymso} (see description in KALLS     21 #   +-< ${kallsymso} (see description in KALLSYMS section)
 20 #                                                  22 #
 21 # vmlinux version (uname -v) cannot be updated     23 # vmlinux version (uname -v) cannot be updated during normal
 22 # descending-into-subdirs phase since we do no     24 # descending-into-subdirs phase since we do not yet know if we need to
 23 # update vmlinux.                                  25 # update vmlinux.
 24 # Therefore this step is delayed until just be     26 # Therefore this step is delayed until just before final link of vmlinux.
 25 #                                                  27 #
 26 # System.map is generated to document addresse     28 # System.map is generated to document addresses of all kernel symbols
 27                                                    29 
 28 # Error out on error                               30 # Error out on error
 29 set -e                                             31 set -e
 30                                                    32 
 31 LD="$1"                                        << 
 32 KBUILD_LDFLAGS="$2"                            << 
 33 LDFLAGS_vmlinux="$3"                           << 
 34                                                << 
 35 is_enabled() {                                 << 
 36         grep -q "^$1=y" include/config/auto.co << 
 37 }                                              << 
 38                                                << 
 39 # Nice output in kbuild format                     33 # Nice output in kbuild format
 40 # Will be supressed by "make -s"                   34 # Will be supressed by "make -s"
 41 info()                                             35 info()
 42 {                                                  36 {
 43         printf "  %-7s %s\n" "${1}" "${2}"     !!  37         if [ "${quiet}" != "silent_" ]; then
                                                   >>  38                 printf "  %-7s %s\n" "${1}" "${2}"
                                                   >>  39         fi
                                                   >>  40 }
                                                   >>  41 
                                                   >>  42 # Link of vmlinux.o used for section mismatch analysis
                                                   >>  43 # ${1} output file
                                                   >>  44 modpost_link()
                                                   >>  45 {
                                                   >>  46         local objects
                                                   >>  47 
                                                   >>  48         objects="--whole-archive                                \
                                                   >>  49                 ${KBUILD_VMLINUX_OBJS}                          \
                                                   >>  50                 --no-whole-archive                              \
                                                   >>  51                 --start-group                                   \
                                                   >>  52                 ${KBUILD_VMLINUX_LIBS}                          \
                                                   >>  53                 --end-group"
                                                   >>  54 
                                                   >>  55         ${LD} ${KBUILD_LDFLAGS} -r -o ${1} ${objects}
 44 }                                                  56 }
 45                                                    57 
 46 # Link of vmlinux                                  58 # Link of vmlinux
 47 # ${1} - output file                               59 # ${1} - output file
                                                   >>  60 # ${2}, ${3}, ... - optional extra .o files
 48 vmlinux_link()                                     61 vmlinux_link()
 49 {                                                  62 {
                                                   >>  63         local lds="${objtree}/${KBUILD_LDS}"
 50         local output=${1}                          64         local output=${1}
 51         local objs                             !!  65         local objects
 52         local libs                             !!  66         local strip_debug
 53         local ld                               << 
 54         local ldflags                          << 
 55         local ldlibs                           << 
 56                                                    67 
 57         info LD ${output}                          68         info LD ${output}
 58                                                    69 
 59         # skip output file argument                70         # skip output file argument
 60         shift                                      71         shift
 61                                                    72 
 62         if is_enabled CONFIG_LTO_CLANG || is_e << 
 63                 # Use vmlinux.o instead of per << 
 64                 objs=vmlinux.o                 << 
 65                 libs=                          << 
 66         else                                   << 
 67                 objs=vmlinux.a                 << 
 68                 libs="${KBUILD_VMLINUX_LIBS}"  << 
 69         fi                                     << 
 70                                                << 
 71         if is_enabled CONFIG_MODULES; then     << 
 72                 objs="${objs} .vmlinux.export. << 
 73         fi                                     << 
 74                                                << 
 75         objs="${objs} init/version-timestamp.o << 
 76                                                << 
 77         if [ "${SRCARCH}" = "um" ]; then       << 
 78                 wl=-Wl,                        << 
 79                 ld="${CC}"                     << 
 80                 ldflags="${CFLAGS_vmlinux}"    << 
 81                 ldlibs="-lutil -lrt -lpthread" << 
 82         else                                   << 
 83                 wl=                            << 
 84                 ld="${LD}"                     << 
 85                 ldflags="${KBUILD_LDFLAGS} ${L << 
 86                 ldlibs=                        << 
 87         fi                                     << 
 88                                                << 
 89         ldflags="${ldflags} ${wl}--script=${ob << 
 90                                                << 
 91         # The kallsyms linking does not need d     73         # The kallsyms linking does not need debug symbols included.
 92         if [ -n "${strip_debug}" ] ; then      !!  74         if [ "$output" != "${output#.tmp_vmlinux.kallsyms}" ] ; then
 93                 ldflags="${ldflags} ${wl}--str !!  75                 strip_debug=-Wl,--strip-debug
 94         fi                                         76         fi
 95                                                    77 
 96         if is_enabled CONFIG_VMLINUX_MAP; then !!  78         if [ "${SRCARCH}" != "um" ]; then
 97                 ldflags="${ldflags} ${wl}-Map= !!  79                 objects="--whole-archive                        \
                                                   >>  80                         ${KBUILD_VMLINUX_OBJS}                  \
                                                   >>  81                         --no-whole-archive                      \
                                                   >>  82                         --start-group                           \
                                                   >>  83                         ${KBUILD_VMLINUX_LIBS}                  \
                                                   >>  84                         --end-group                             \
                                                   >>  85                         ${@}"
                                                   >>  86 
                                                   >>  87                 ${LD} ${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux}      \
                                                   >>  88                         ${strip_debug#-Wl,}                     \
                                                   >>  89                         -o ${output}                            \
                                                   >>  90                         -T ${lds} ${objects}
                                                   >>  91         else
                                                   >>  92                 objects="-Wl,--whole-archive                    \
                                                   >>  93                         ${KBUILD_VMLINUX_OBJS}                  \
                                                   >>  94                         -Wl,--no-whole-archive                  \
                                                   >>  95                         -Wl,--start-group                       \
                                                   >>  96                         ${KBUILD_VMLINUX_LIBS}                  \
                                                   >>  97                         -Wl,--end-group                         \
                                                   >>  98                         ${@}"
                                                   >>  99 
                                                   >> 100                 ${CC} ${CFLAGS_vmlinux}                         \
                                                   >> 101                         ${strip_debug}                          \
                                                   >> 102                         -o ${output}                            \
                                                   >> 103                         -Wl,-T,${lds}                           \
                                                   >> 104                         ${objects}                              \
                                                   >> 105                         -lutil -lrt -lpthread
                                                   >> 106                 rm -f linux
 98         fi                                        107         fi
 99                                                << 
100         ${ld} ${ldflags} -o ${output}          << 
101                 ${wl}--whole-archive ${objs} $ << 
102                 ${wl}--start-group ${libs} ${w << 
103                 ${kallsymso} ${btf_vmlinux_bin << 
104 }                                                 108 }
105                                                   109 
106 # generate .BTF typeinfo from DWARF debuginfo     110 # generate .BTF typeinfo from DWARF debuginfo
107 # ${1} - vmlinux image                            111 # ${1} - vmlinux image
                                                   >> 112 # ${2} - file to dump raw BTF data into
108 gen_btf()                                         113 gen_btf()
109 {                                                 114 {
110         local pahole_ver                          115         local pahole_ver
111         local btf_data=${1}.btf.o              << 
112                                                   116 
113         if ! [ -x "$(command -v ${PAHOLE})" ];    117         if ! [ -x "$(command -v ${PAHOLE})" ]; then
114                 echo >&2 "BTF: ${1}: pahole ($    118                 echo >&2 "BTF: ${1}: pahole (${PAHOLE}) is not available"
115                 return 1                          119                 return 1
116         fi                                        120         fi
117                                                   121 
118         pahole_ver=$(${PAHOLE} --version | sed    122         pahole_ver=$(${PAHOLE} --version | sed -E 's/v([0-9]+)\.([0-9]+)/\1\2/')
119         if [ "${pahole_ver}" -lt "116" ]; then !! 123         if [ "${pahole_ver}" -lt "113" ]; then
120                 echo >&2 "BTF: ${1}: pahole ve !! 124                 echo >&2 "BTF: ${1}: pahole version $(${PAHOLE} --version) is too old, need at least v1.13"
121                 return 1                          125                 return 1
122         fi                                        126         fi
123                                                   127 
124         info BTF "${btf_data}"                 !! 128         vmlinux_link ${1}
125         LLVM_OBJCOPY="${OBJCOPY}" ${PAHOLE} -J !! 129 
                                                   >> 130         info "BTF" ${2}
                                                   >> 131         LLVM_OBJCOPY=${OBJCOPY} ${PAHOLE} -J ${1}
126                                                   132 
127         # Create ${btf_data} which contains ju !! 133         # Create ${2} which contains just .BTF section but no symbols. Add
128         # SHF_ALLOC because .BTF will be part     134         # SHF_ALLOC because .BTF will be part of the vmlinux image. --strip-all
129         # deletes all symbols including __star    135         # deletes all symbols including __start_BTF and __stop_BTF, which will
130         # be redefined in the linker script. A    136         # be redefined in the linker script. Add 2>/dev/null to suppress GNU
131         # objcopy warnings: "empty loadable se    137         # objcopy warnings: "empty loadable segment detected at ..."
132         ${OBJCOPY} --only-section=.BTF --set-s    138         ${OBJCOPY} --only-section=.BTF --set-section-flags .BTF=alloc,readonly \
133                 --strip-all ${1} "${btf_data}" !! 139                 --strip-all ${1} ${2} 2>/dev/null
134         # Change e_type to ET_REL so that it c    140         # Change e_type to ET_REL so that it can be used to link final vmlinux.
135         # GNU ld 2.35+ and lld do not allow an    141         # GNU ld 2.35+ and lld do not allow an ET_EXEC input.
136         if is_enabled CONFIG_CPU_BIG_ENDIAN; t !! 142         if [ -n "${CONFIG_CPU_BIG_ENDIAN}" ]; then
137                 et_rel='\0\1'                     143                 et_rel='\0\1'
138         else                                      144         else
139                 et_rel='\1\0'                     145                 et_rel='\1\0'
140         fi                                        146         fi
141         printf "${et_rel}" | dd of="${btf_data !! 147         printf "${et_rel}" | dd of=${2} conv=notrunc bs=1 seek=16 status=none
142                                                << 
143         btf_vmlinux_bin_o=${btf_data}          << 
144 }                                                 148 }
145                                                   149 
146 # Create ${2}.o file with all symbols from the !! 150 # Create ${2} .o file with all symbols from the ${1} object file
147 kallsyms()                                        151 kallsyms()
148 {                                                 152 {
                                                   >> 153         info KSYM ${2}
149         local kallsymopt;                         154         local kallsymopt;
150                                                   155 
151         if is_enabled CONFIG_KALLSYMS_ALL; the !! 156         if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
152                 kallsymopt="${kallsymopt} --al    157                 kallsymopt="${kallsymopt} --all-symbols"
153         fi                                        158         fi
154                                                   159 
155         if is_enabled CONFIG_KALLSYMS_ABSOLUTE !! 160         if [ -n "${CONFIG_KALLSYMS_ABSOLUTE_PERCPU}" ]; then
156                 kallsymopt="${kallsymopt} --ab    161                 kallsymopt="${kallsymopt} --absolute-percpu"
157         fi                                        162         fi
158                                                   163 
159         info KSYMS "${2}.S"                    !! 164         if [ -n "${CONFIG_KALLSYMS_BASE_RELATIVE}" ]; then
160         scripts/kallsyms ${kallsymopt} "${1}"  !! 165                 kallsymopt="${kallsymopt} --base-relative"
                                                   >> 166         fi
                                                   >> 167 
                                                   >> 168         local aflags="${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL}               \
                                                   >> 169                       ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS}"
161                                                   170 
162         info AS "${2}.o"                       !! 171         local afile="`basename ${2} .o`.S"
163         ${CC} ${NOSTDINC_FLAGS} ${LINUXINCLUDE << 
164               ${KBUILD_AFLAGS} ${KBUILD_AFLAGS << 
165                                                   172 
166         kallsymso=${2}.o                       !! 173         ${NM} -n ${1} | scripts/kallsyms ${kallsymopt} > ${afile}
                                                   >> 174         ${CC} ${aflags} -c -o ${2} ${afile}
167 }                                                 175 }
168                                                   176 
169 # Perform kallsyms for the given temporary vml !! 177 # Perform one step in kallsyms generation, including temporary linking of
170 sysmap_and_kallsyms()                          !! 178 # vmlinux.
                                                   >> 179 kallsyms_step()
171 {                                                 180 {
172         mksysmap "${1}" "${1}.syms"            !! 181         kallsymso_prev=${kallsymso}
173         kallsyms "${1}.syms" "${1}.kallsyms"   !! 182         kallsyms_vmlinux=.tmp_vmlinux.kallsyms${1}
                                                   >> 183         kallsymso=${kallsyms_vmlinux}.o
174                                                   184 
175         kallsyms_sysmap=${1}.syms              !! 185         vmlinux_link ${kallsyms_vmlinux} "${kallsymso_prev}" ${btf_vmlinux_bin_o}
                                                   >> 186         kallsyms ${kallsyms_vmlinux} ${kallsymso}
176 }                                                 187 }
177                                                   188 
178 # Create map file with all symbols from ${1}      189 # Create map file with all symbols from ${1}
179 # See mksymap for additional details              190 # See mksymap for additional details
180 mksysmap()                                        191 mksysmap()
181 {                                                 192 {
182         info NM ${2}                           !! 193         ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
183         ${NM} -n "${1}" | sed -f "${srctree}/s << 
184 }                                                 194 }
185                                                   195 
186 sorttable()                                    !! 196 sortextable()
187 {                                                 197 {
188         ${objtree}/scripts/sorttable ${1}      !! 198         ${objtree}/scripts/sortextable ${1}
189 }                                                 199 }
190                                                   200 
                                                   >> 201 # Delete output files in case of error
191 cleanup()                                         202 cleanup()
192 {                                                 203 {
193         rm -f .btf.*                              204         rm -f .btf.*
                                                   >> 205         rm -f .tmp_System.map
                                                   >> 206         rm -f .tmp_vmlinux*
194         rm -f System.map                          207         rm -f System.map
195         rm -f vmlinux                             208         rm -f vmlinux
196         rm -f vmlinux.map                      !! 209         rm -f vmlinux.o
197 }                                                 210 }
198                                                   211 
                                                   >> 212 on_exit()
                                                   >> 213 {
                                                   >> 214         if [ $? -ne 0 ]; then
                                                   >> 215                 cleanup
                                                   >> 216         fi
                                                   >> 217 }
                                                   >> 218 trap on_exit EXIT
                                                   >> 219 
                                                   >> 220 on_signals()
                                                   >> 221 {
                                                   >> 222         exit 1
                                                   >> 223 }
                                                   >> 224 trap on_signals HUP INT QUIT TERM
                                                   >> 225 
                                                   >> 226 #
                                                   >> 227 #
199 # Use "make V=1" to debug this script             228 # Use "make V=1" to debug this script
200 case "${KBUILD_VERBOSE}" in                       229 case "${KBUILD_VERBOSE}" in
201 *1*)                                              230 *1*)
202         set -x                                    231         set -x
203         ;;                                        232         ;;
204 esac                                              233 esac
205                                                   234 
206 if [ "$1" = "clean" ]; then                       235 if [ "$1" = "clean" ]; then
207         cleanup                                   236         cleanup
208         exit 0                                    237         exit 0
209 fi                                                238 fi
210                                                   239 
211 ${MAKE} -f "${srctree}/scripts/Makefile.build" !! 240 # We need access to CONFIG_ symbols
212                                                !! 241 . include/config/auto.conf
213 btf_vmlinux_bin_o=                             << 
214 kallsymso=                                     << 
215 strip_debug=                                   << 
216                                                << 
217 if is_enabled CONFIG_KALLSYMS; then            << 
218         truncate -s0 .tmp_vmlinux.kallsyms0.sy << 
219         kallsyms .tmp_vmlinux.kallsyms0.syms . << 
220 fi                                             << 
221                                                << 
222 if is_enabled CONFIG_KALLSYMS || is_enabled CO << 
223                                                   242 
224         # The kallsyms linking does not need d !! 243 # Update version
225         if ! is_enabled CONFIG_DEBUG_INFO_BTF; !! 244 info GEN .version
226                 strip_debug=1                  !! 245 if [ -r .version ]; then
227         fi                                     !! 246         VERSION=$(expr 0$(cat .version) + 1)
228                                                !! 247         echo $VERSION > .version
229         vmlinux_link .tmp_vmlinux1             !! 248 else
230 fi                                             !! 249         rm -f .version
231                                                !! 250         echo 1 > .version
232 if is_enabled CONFIG_DEBUG_INFO_BTF; then      !! 251 fi;
233         if ! gen_btf .tmp_vmlinux1; then       !! 252 
                                                   >> 253 # final build of init/
                                                   >> 254 ${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init
                                                   >> 255 
                                                   >> 256 #link vmlinux.o
                                                   >> 257 info LD vmlinux.o
                                                   >> 258 modpost_link vmlinux.o
                                                   >> 259 
                                                   >> 260 # modpost vmlinux.o to check for section mismatches
                                                   >> 261 ${MAKE} -f "${srctree}/scripts/Makefile.modpost" MODPOST_VMLINUX=1
                                                   >> 262 
                                                   >> 263 info MODINFO modules.builtin.modinfo
                                                   >> 264 ${OBJCOPY} -j .modinfo -O binary vmlinux.o modules.builtin.modinfo
                                                   >> 265 
                                                   >> 266 btf_vmlinux_bin_o=""
                                                   >> 267 if [ -n "${CONFIG_DEBUG_INFO_BTF}" ]; then
                                                   >> 268         btf_vmlinux_bin_o=.btf.vmlinux.bin.o
                                                   >> 269         if ! gen_btf .tmp_vmlinux.btf $btf_vmlinux_bin_o ; then
234                 echo >&2 "Failed to generate B    270                 echo >&2 "Failed to generate BTF for vmlinux"
235                 echo >&2 "Try to disable CONFI    271                 echo >&2 "Try to disable CONFIG_DEBUG_INFO_BTF"
236                 exit 1                            272                 exit 1
237         fi                                        273         fi
238 fi                                                274 fi
239                                                   275 
240 if is_enabled CONFIG_KALLSYMS; then            !! 276 kallsymso=""
                                                   >> 277 kallsymso_prev=""
                                                   >> 278 kallsyms_vmlinux=""
                                                   >> 279 if [ -n "${CONFIG_KALLSYMS}" ]; then
241                                                   280 
242         # kallsyms support                        281         # kallsyms support
243         # Generate section listing all symbols    282         # Generate section listing all symbols and add it into vmlinux
244         # It's a four step process:            !! 283         # It's a three step process:
245         # 0)  Generate a dummy __kallsyms with !! 284         # 1)  Link .tmp_vmlinux1 so it has all symbols and sections,
246         # 1)  Link .tmp_vmlinux.kallsyms1 so i !! 285         #     but __kallsyms is empty.
247         #     with a dummy __kallsyms.         << 
248         #     Running kallsyms on that gives u    286         #     Running kallsyms on that gives us .tmp_kallsyms1.o with
249         #     the right size                      287         #     the right size
250         # 2)  Link .tmp_vmlinux.kallsyms2 so i !! 288         # 2)  Link .tmp_vmlinux2 so it now has a __kallsyms section of
251         #     the right size, but due to the a    289         #     the right size, but due to the added section, some
252         #     addresses have shifted.             290         #     addresses have shifted.
253         #     From here, we generate a correct !! 291         #     From here, we generate a correct .tmp_kallsyms2.o
254         # 3)  That link may have expanded the     292         # 3)  That link may have expanded the kernel image enough that
255         #     more linker branch stubs / tramp    293         #     more linker branch stubs / trampolines had to be added, which
256         #     introduces new names, which furt    294         #     introduces new names, which further expands kallsyms. Do another
257         #     pass if that is the case. In the    295         #     pass if that is the case. In theory it's possible this results
258         #     in even more stubs, but unlikely    296         #     in even more stubs, but unlikely.
259         #     KALLSYMS_EXTRA_PASS=1 may also u    297         #     KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
260         #     other bugs.                         298         #     other bugs.
261         # 4)  The correct ${kallsymso} is link    299         # 4)  The correct ${kallsymso} is linked into the final vmlinux.
262         #                                         300         #
263         # a)  Verify that the System.map from     301         # a)  Verify that the System.map from vmlinux matches the map from
264         #     ${kallsymso}.                       302         #     ${kallsymso}.
265                                                   303 
266         # The kallsyms linking does not need d !! 304         kallsyms_step 1
267         strip_debug=1                          !! 305         kallsyms_step 2
268                                                << 
269         sysmap_and_kallsyms .tmp_vmlinux1      << 
270         size1=$(${CONFIG_SHELL} "${srctree}/sc << 
271                                                   306 
272         vmlinux_link .tmp_vmlinux2             !! 307         # step 3
273         sysmap_and_kallsyms .tmp_vmlinux2      !! 308         size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso_prev})
274         size2=$(${CONFIG_SHELL} "${srctree}/sc    309         size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso})
275                                                   310 
276         if [ $size1 -ne $size2 ] || [ -n "${KA    311         if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
277                 vmlinux_link .tmp_vmlinux3     !! 312                 kallsyms_step 3
278                 sysmap_and_kallsyms .tmp_vmlin << 
279         fi                                        313         fi
280 fi                                                314 fi
281                                                   315 
282 strip_debug=                                   !! 316 vmlinux_link vmlinux "${kallsymso}" ${btf_vmlinux_bin_o}
283                                                << 
284 vmlinux_link vmlinux                           << 
285                                                   317 
286 # fill in BTF IDs                              !! 318 if [ -n "${CONFIG_BUILDTIME_EXTABLE_SORT}" ]; then
287 if is_enabled CONFIG_DEBUG_INFO_BTF && is_enab !! 319         info SORTEX vmlinux
288         info BTFIDS vmlinux                    !! 320         sortextable vmlinux
289         ${RESOLVE_BTFIDS} vmlinux              << 
290 fi                                                321 fi
291                                                   322 
                                                   >> 323 info SYSMAP System.map
292 mksysmap vmlinux System.map                       324 mksysmap vmlinux System.map
293                                                   325 
294 if is_enabled CONFIG_BUILDTIME_TABLE_SORT; the << 
295         info SORTTAB vmlinux                   << 
296         if ! sorttable vmlinux; then           << 
297                 echo >&2 Failed to sort kernel << 
298                 exit 1                         << 
299         fi                                     << 
300 fi                                             << 
301                                                << 
302 # step a (see comment above)                      326 # step a (see comment above)
303 if is_enabled CONFIG_KALLSYMS; then            !! 327 if [ -n "${CONFIG_KALLSYMS}" ]; then
304         if ! cmp -s System.map "${kallsyms_sys !! 328         mksysmap ${kallsyms_vmlinux} .tmp_System.map
                                                   >> 329 
                                                   >> 330         if ! cmp -s System.map .tmp_System.map; then
305                 echo >&2 Inconsistent kallsyms    331                 echo >&2 Inconsistent kallsyms data
306                 echo >&2 'Try "make KALLSYMS_E !! 332                 echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
307                 exit 1                            333                 exit 1
308         fi                                        334         fi
309 fi                                                335 fi
310                                                << 
311 # For fixdep                                   << 
312 echo "vmlinux: $0" > .vmlinux.d                << 
                                                      

~ [ source navigation ] ~ [ diff markup ] ~ [ identifier search ] ~

kernel.org | git.kernel.org | LWN.net | Project Home | SVN repository | Mail admin

Linux® is a registered trademark of Linus Torvalds in the United States and other countries.
TOMOYO® is a registered trademark of NTT DATA CORPORATION.

sflogo.php